import Http from "../../utils/http"

export default class {
  execute(properties, target, controller) {
    const form = target.closest("form")
    // Analogous to Rails' form_with's local
    if (form.dataset.local) {
      // This action works well with browser's native behaviour, e.g. pressing
      // ENTER on the keyboard will submit the form.
      form.submit()
    }
    else {
      const data = {
        url: form.getAttribute("action"),
        formData: new FormData(form),
        formDataEncoded: true
      }
      Http.execute(data, form.getAttribute("method"), controller, (response) => Action.execute(response['onResponse'], target, controller))
    }
  }
}

// From: https://gist.github.com/Kelderic/8eefc37741e3005852051a4e95ccd2ab
HTMLFormElement.prototype.toMap = function() {
  var data = {};

  for ( var i = 0; i < this.elements.length; i++ ) {
    if ( this.elements[i].name === '' ) {
      continue;
    }
    switch ( this.elements[i].nodeName ) {
      case 'INPUT':
        switch ( this.elements[i].type ) {
          case 'file':
          case 'submit':
          case 'button':
            break;
          case 'checkbox':
          case 'radio':
            if ( this.elements[i].checked ) {
              data[this.elements[i].name] = this.elements[i].value;
            }
            break;
          default:
            data[this.elements[i].name] = this.elements[i].value;
            break;
        }
        break;
      case 'TEXTAREA':
        data[this.elements[i].name] = this.elements[i].value;
        break;
      case 'SELECT':
        switch ( this.elements[i].type ) {
          case 'select-one':
            data[this.elements[i].name] = this.elements[i].value;
            break;
          case 'select-multiple':
            for ( var j = this.elements[i].options.length - 1; j >= 0; j-- ) {
              if ( this.elements[i].options[j].selected ) {
                data[this.elements[i].name] = this.elements[i].value;
              }
            }
            break;
        }
        break;
    }
  }

  return data;
};
