export default class {
  static isObject(obj) {
    return typeof obj === 'object' && obj !== null
  }
  static isString(obj) {
    return typeof obj === 'string'
  }
  static isNumber(obj) {
    return typeof obj === 'number'
  }
  static isArray(obj) {
    return this.isObject(obj) && Array.isArray(obj)
  }

  static ifObject(obj, command) {
    if (this.isObject(obj)) {
      command(obj)
    }
  }
  static ifString(obj, command) {
    if (this.isString(obj)) {
      command(obj)
    }
  }
  static ifNumber(obj, command) {
    if (this.isNumber(obj)) {
      command(obj)
    }
  }
  static ifArray(obj, command) {
    if (this.isArray(obj)) {
      command(obj)
    }
  }
}

// TODO: Move this to files specific for extensions so it's clear
// https://stackoverflow.com/questions/7616461/generate-a-hash-from-string-in-javascript
String.prototype.hashCode = function() {
  var hash = 0, i, chr;
  if (this.length === 0) return hash;
  for (i = 0; i < this.length; i++) {
    chr   = this.charCodeAt(i);
    hash  = ((hash << 5) - hash) + chr;
    hash |= 0; // Convert to 32bit integer
  }
  return hash;
}

Array.prototype.clear = function() {
  this.length = 0
}
